; Abre um arquivo
; ds:si = Endereço
; ret: cf = 1=Aberto | 0=Nao foi possivel abrir
;      bx = id do arquivo
_ArqAbrir:
    push ax
    push dx
    mov ah, 0x3d
    mov dx, si
    int 0x21
    jnc .ok
        mov bx, ax
        clc
        jmp .fim
    .ok:
        xor bx, bx
        stc
    .fim:
    pop dx
    pop ax
    retf

; Fecha um arquivo aberto
; bx = Id do Arquivo
; ret: cf = 1=Fechado | 0=Nao foi possivel fechar
_ArqFechar:
    push ax
    push dx
    mov ah, 0x3e
    int 0x21
    jnc .ok
        clc
        jmp .fim
    .ok:
        stc
    .fim:
    pop dx
    pop ax
    retf

; Le um arquivo
; bx = Id do Arquivo
; cx = Quantidade de Bytes
; ds:di = Destino
; ret: cf = 1=Lido | 0=Não foi possivel ler
;      cx = Quantidade de Bytes Lidos
_ArqLerLocal:
    push ax
    push dx
    mov ah, 0x3f
    mov dx, di
    int 0x21
    jnc .ok
        xor cx, cx
        clc
        jmp .fim
    .ok:
        mov cx, ax
        stc
    .fim:
    pop dx
    pop ax
    retf

; Le um arquivo
; bx = Id do Arquivo
; cx = Quantidade de Bytes
; es:di = Destino
; ret: cf = 1=Lido | 0=Não foi possivel ler
;      cx = Quantidade de Bytes Lidos
_ArqLerRemoto:
    push ax
    push dx
    push ds
    
    push es
    pop ds
    
    mov ah, 0x3f
    mov dx, di
    int 0x21
    jnc .ok
        xor cx, cx
        clc
        jmp .fim
    .ok:
        mov cx, ax
        stc
    .fim:
    
    pop ds
    pop dx
    pop ax
    retf

; Grava um arquivo
; bx = Id do Arquivo
; cx = Quantidade de Bytes
; ds:si = Origem
; ret: cf = 1=Lido | 0=Não foi possivel ler
;      cx = Quantidade de Bytes Lidos
_ArqGravarLocal:
    push ax
    push dx
    mov ah, 0x40
    mov dx, si
    int 0x21
    jnc .ok
        xor cx, cx
        clc
        jmp .fim
    .ok:
        mov cx, ax
        stc
    .fim:
    pop dx
    pop ax
    retf

; Grava um arquivo
; bx = Id do Arquivo
; cx = Quantidade de Bytes
; es:si = Destino
; ret: cf = 1=Lido | 0=Não foi possivel ler
;      cx = Quantidade de Bytes Lidos
_ArqGravarRemoto:
    push ax
    push dx
    push ds
    
    push es
    pop ds
    
    mov ah, 0x40
    mov dx, si
    int 0x21
    jnc .ok
        xor cx, cx
        clc
        jmp .fim
    .ok:
        mov cx, ax
        stc
    .fim:
    
    pop ds
    pop dx
    pop ax
    retf

; Ir para posicao no arquivo
; dx:ax = Posicao
; bx = Id do Arquivo
; ret: cf = 1=Alterada posicao | 0=Não foi possivel
;      dx:ax = Posicao
_ArqIrPara:
    push cx
    xchg ax, dx
    mov cx, ax
    mov ah, 0x42
    int 0x21
    jnc .ok
        xor ax, ax
        xor dx, dx
        clc
        jmp .fim
    .ok:
        stc
    .fim:
    pop cx
    retf
