
_TermEscreverC:
    push ax
    push dx
    mov ah, 0x2
    mov dl, al
    int 0x21
    pop dx
    pop ax
    retf

_TermEscrever:
    push bp
    mov bp, sp
    push si
    mov si, [bp+2]
    
    push ds
    
    push cs
    pop ds
    
    push cs
    call _TermEscreverLocalSIInterno
    
    pop ds
    
    mov [bp+2], si
    pop si
    mov sp, bp
    pop bp
    retf
    
_TermEscreverLocalSISimples:
    push bp
    mov bp, sp
    push si
    push ax
    push bx
    .repetir:
        lodsb
        cmp al, 0
        je .fim
        push cs
        call _TermEscreverC
        jmp .repetir
    .fim:
    pop bx
    pop ax
    pop si
    mov sp, bp
    pop bp
    retf
    
_TermEscreverRemotoSISimples:
    push bp
    mov bp, sp
    push si
    push ax
    push bx
    .repetir:
        es lodsb
        cmp al, 0
        je .fim
        push cs
        call _TermEscreverC
        jmp .repetir
    .fim:
    pop bx
    pop ax
    pop si
    mov sp, bp
    pop bp
    retf
    
_TermEscreverLocalSIInterno:
    push ax
    push bx
    push bp
    mov bp, sp
    .a: equ -2
    .b: equ -4
    .c: equ -6
    .d: equ -8
    
    push ax
    push bx
    push cx
    push dx
    
    .repetir:
        lodsb
        cmp al, 0
        je .fim
        cmp al, '\'
        jne .comum
            lodsb
            cmp al, 0
            je .fim
            cmp al, 'a'
            jne .naoA
                mov bx, [bp+.a]
                jmp .fimReg
            .naoA:
            cmp al, 'b'
            jne .naoB
                mov bx, [bp+.b]
                jmp .fimReg
            .naoB:
            cmp al, 'c'
            jne .naoC
                mov bx, [bp+.c]
                jmp .fimReg
            .naoC:
            cmp al, 'd'
            jne .naoD
                mov bx, [bp+.d]
                jmp .fimReg
            .naoD:
            cmp al, 'n'
            jne .naoN
                mov al, 10
                push cs
                call _TermEscreverC
                mov al, 13
                jmp .comum
            .naoN:
            cmp al, 't'
            jne .naoT
                mov al, 32
                jmp .comum
            .naoT:
            jmp .comum
            .fimReg:
            ; Processa o que fazer
            lodsb
            cmp al, 'i'
            je .int
            cmp al, 'r'
            je .txtRemoto
            jmp .repetir
            .int:
                mov ax, bx
                push cs
                call _TermEscreverNro
                jmp .repetir
            .txtRemoto:
                mov si, bx
                push cs
                call _TermEscreverRemotoSISimples
                jmp .repetir
        .comum:
        push cs
        call _TermEscreverC
        jmp .repetir
    .fim:
    mov sp, bp
    pop bp
    pop bx
    pop ax
    retf
    
    
_TermEscreverLocalSI:
    push si
    push cs
    call _TermEscreverLocalSIInterno
    pop si
    retf
    
_TermEscreverRemotoSI:
    push ds
    push es
    pop ds
    push cs
    call _TermEscreverLocalSIInterno
    pop ds
    retf

_TermEscreverNro:
    push ax
    push dx
    xor dx, dx
    cs div word [.valor]
    cmp ax, 0
    je .fim
        push cs
        call _TermEscreverNro
    .fim:
    mov al, dl
    add al, '0'
    push cs
    call _TermEscreverC
    pop dx
    pop ax
    retf
    .valor: dw 10
