cli
mov ax, 0x7c0
mov ds, ax
mov ax, 0x600
mov ss, ax
mov sp, 1024
sti
mov ax, 0x7c0
push ax
mov ax, Inicial
push ax
retf


Inicial:
    mov [Params.Disco], dl

    call termEscrever
    db "Setor Inicial v22.4 R70",0

    int 0x12
    call termEscrever
    db " [RAM: ",0
    call termEscreverInt
    call termEscrever
    db " KiB] ",0
    mov bx, 64
    mul bx
    dec ax

    mov [Params.Ultimo], ax
    cs mov cx, [Config.Quantidade]
    .calcula:
        sub ax, 64
        loop .calcula
    mov [Params.Destino], ax
    mov es, ax
    
    
    xor bx, bx
    cs mov cx, [Config.Quantidade]
    cs mov ax, [Config.Posicao]
    .carregamento:
        call discoLer
        inc ax
        add bx, 1024
        loop .carregamento

    call termEscrever
    db " [ OK ]", 13, 10, 0
    mov ax, es
    mov ds, ax
    cs push word [Params.Destino]
    xor ax, ax
    push ax
    retf



infinito:
    hlt
    jmp infinito

termPonto:
    pushf
    call termEscrever
    db ".",0
    popf
    ret

termEscreverInt:
    pushf
    push ax
    push bx
    push dx
    push ds
    push cs
    pop ds
    xor dx, dx
    cs div word [.divisao]
    cmp ax, 0
    je .fim
        call termEscreverInt
    .fim:
    mov ax, dx
    mov bx, .tabela
    xlat
    mov ah, 0xe
    int 0x10
    pop ds
    pop dx
    pop bx
    pop ax
    popf
    ret
    .divisao: dw 10
    .tabela: db "0123456789"


termEscrever:
    push bp
    mov bp, sp
    push si
    push ax
    mov si, [bp + 2]
    .repetir:
        cs lodsb
        cmp al, 0
        je .fim
        mov ah, 0xe
        int 0x10
        jmp .repetir
    .fim:
    mov [bp + 2], si
    pop ax
    pop si
    mov sp, bp
    pop bp
    ret

discoLer:
    push ax
    push bx
    push ds
    push cs
    pop ds
    call termPonto
    shl ax, 1
    call discoLerBloco
    inc ax
    add bx, 512
    call discoLerBloco
    pop ds
    pop bx
    pop ax
    ret

discoLerBloco:
    push ax
    push bx
    push cx
    push dx
    xor dx, dx
    cs div word [Config.Setores]
    mov cl, dl
    inc cl
    xor dx, dx
    cs div word [Config.Cabecas]
    mov ch, al
    mov dh, dl
    cs mov dl, [Params.Disco]
    mov al, 1
    mov ah, 2
    .tentativa:
    push ax
    push bx
    push cx
    push dx
    int 0x13
    jnc .fim
        xor ax, ax
        cs mov dl, [Params.Disco]
        int 0x13
        call termEscrever
        db "#",0
        pop dx
        pop cx
        pop bx
        pop ax
        jmp .tentativa
    .fim:
    pop dx
    pop cx
    pop bx
    pop ax
    pop dx
    pop cx
    pop bx
    pop ax
    ret

Params:
    .Disco: dw 0
    .Destino: dw 0
    .Ultimo: dw 0
    .Posicao: dw 0
times 400-($-$$) db 0
db "HC"
